org.apache.lucene.util.packed

## Class DirectMonotonicReader

- java.lang.Object
- - org.apache.lucene.util.LongValues
  - - org.apache.lucene.util.packed.DirectMonotonicReader

All Implemented Interfaces:
  Accountable

    public final class DirectMonotonicReader
    extends LongValues
    implements Accountable

Retrieves an instance previously written by `DirectMonotonicWriter`.

See Also:
  `DirectMonotonicWriter`

### Nested Class Summary

Nested Classes
`static class` `DirectMonotonicReader.Meta` In-memory metadata that needs to be kept around for `DirectMonotonicReader` to read data from disk.

### Field Summary

### Fields inherited from class org.apache.lucene.util.LongValues

`IDENTITY, ZEROES`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`long` `binarySearch(long fromIndex, long toIndex, long key)` Return the index of a key if it exists, or its insertion point otherwise like `Arrays.binarySearch(long[], int, int, long)`.
`long` `get(long index)` Get value at `index`.
`static DirectMonotonicReader` `getInstance(DirectMonotonicReader.Meta meta, RandomAccessInput data)` Retrieves an instance from the specified slice.
`static DirectMonotonicReader.Meta` `loadMeta(IndexInput metaIn, long numValues, int blockShift)` Load metadata from the given `IndexInput`.
`long` `ramBytesUsed()` Return the memory usage of this object in bytes.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.lucene.util.Accountable

`getChildResources`

### Method Detail

#### loadMeta

    public static DirectMonotonicReader.Meta loadMeta(IndexInput metaIn,
                                                      long numValues,
                                                      int blockShift)
                                               throws IOException

Load metadata from the given `IndexInput`.

Throws:
  `IOException`
See Also:
  `getInstance(Meta, RandomAccessInput)`

#### getInstance

    public static DirectMonotonicReader getInstance(DirectMonotonicReader.Meta meta,
                                                    RandomAccessInput data)
                                             throws IOException

Retrieves an instance from the specified slice.

Throws:
  `IOException`

#### get

    public long get(long index)

Description copied from class: `LongValues`
Get value at `index`.

Specified by:
  `get` in class `LongValues`

#### binarySearch

    public long binarySearch(long fromIndex,
                             long toIndex,
                             long key)

Return the index of a key if it exists, or its insertion point otherwise like `Arrays.binarySearch(long[], int, int, long)`.

See Also:
  `Arrays.binarySearch(long[], int, int, long)`

#### ramBytesUsed

    public long ramBytesUsed()

Description copied from interface: `Accountable`
Return the memory usage of this object in bytes. Negative values are illegal.

Specified by:
  `ramBytesUsed` in interface `Accountable`